# -*- coding: utf-8 -*-
# ---------------------------------------------------------------------------
# zaa.py
# Created on: 2017-01-04 22:21:45.00000
#   (generated by ArcGIS/ModelBuilder)
# Usage: zaa <Area_Of_Interest> <Input_Roads> <Input_Elevation> <Output_Path_Slope> 
# Description: 
# As an data steward I can use Path Slope to find the slope classifications for all of the roads in my Area Of Interest.
# ---------------------------------------------------------------------------

# Set the necessary product code
# import arcinfo


# Import arcpy module
import arcpy

# Script arguments
Area_Of_Interest = arcpy.GetParameterAsText(0)
if Area_Of_Interest == '#' or not Area_Of_Interest:
    Area_Of_Interest = "in_memory\\{E154F31C-1671-485F-9200-B7CAFD423440}" # provide a default value if unspecified

Input_Roads = arcpy.GetParameterAsText(1)

Input_Elevation = arcpy.GetParameterAsText(2)

Output_Path_Slope = arcpy.GetParameterAsText(3)

# Local variables:
aoi = "in_memory\\aoi"
Output_Spatial_Reference = "{B286C06B-0879-11D2-AACA-00C04FA33C20};IsHighPrecision"
buf = "in_memory\\buf"
CellSize = buf
clip__3_ = "in_memory\\clip"
CELLSIZEX = ""
extract = "in_memory\\extract"
slope__3_ = "in_memory\\slope"
Reclassification = "0 3 1;3 10 2;10 15 3;15 20 4;20 30 5;30 45 6;45 60 7;60 85 8;85 10000000000000 9;NODATA 0"
slopeReclass = "in_memory\\slopeReclass"
slopePoly = "in_memory\\slopePoly"
Output_fc = ""
PathSlope__3_ = Output_fc
PathSlope__6_ = PathSlope__3_
PathSlope__4_ = PathSlope__6_

# Process: Copy Features
arcpy.CopyFeatures_management(Area_Of_Interest, aoi, "", "0", "0", "0")

# Process: Create Spatial Reference
arcpy.CreateSpatialReference_management("", Input_Roads, "", "", "", "", "0")

# Process: Buffer
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
arcpy.Buffer_analysis(aoi, buf, "1 Kilometers", "FULL", "ROUND", "NONE", "", "PLANAR")
arcpy.env.outputCoordinateSystem = tempEnvironment0

# Process: Clip
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
arcpy.Clip_analysis(Input_Roads, buf, clip__3_, "")
arcpy.env.outputCoordinateSystem = tempEnvironment0

# Process: Get Raster Properties
arcpy.GetRasterProperties_management(Input_Elevation, "CELLSIZEX", "")

# Process: Calculate Value: CellSize
arcpy.CalculateValue_management("CalcCellSize(r\"%buf%\",\"%CELLSIZEX%\")", "def CalcCellSize(fc,csx):\\n  height = arcpy.Describe(fc).extent.height\\n  width = arcpy.Describe(fc).extent.width\\n  cs = max(height, width)/2000.0\\n  return max(float(cs),float(csx))", "Cell Size")

# Process: Extract by Mask
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
tempEnvironment1 = arcpy.env.cellSize
arcpy.env.cellSize = CellSize
arcpy.gp.ExtractByMask_sa(Input_Elevation, buf, extract)
arcpy.env.outputCoordinateSystem = tempEnvironment0
arcpy.env.cellSize = tempEnvironment1

# Process: Slope
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
arcpy.gp.Slope_sa(extract, slope__3_, "PERCENT_RISE", "1")
arcpy.env.outputCoordinateSystem = tempEnvironment0

# Process: Reclassify
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
arcpy.gp.Reclassify_sa(slope__3_, "Value", Reclassification, slopeReclass, "DATA")
arcpy.env.outputCoordinateSystem = tempEnvironment0

# Process: Raster to Polygon
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
arcpy.RasterToPolygon_conversion(slopeReclass, slopePoly, "SIMPLIFY", "VALUE")
arcpy.env.outputCoordinateSystem = tempEnvironment0

# Process: Identity
tempEnvironment0 = arcpy.env.outputCoordinateSystem
arcpy.env.outputCoordinateSystem = Output Spatial Reference
arcpy.Identity_analysis(clip__3_, slopePoly, Output_fc, "ALL", "", "NO_RELATIONSHIPS")
arcpy.env.outputCoordinateSystem = tempEnvironment0

# Process: Add Field
arcpy.AddField_management(Output_fc, "SPR", "LONG", "", "", "", "Slope Polygon Range", "NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field
arcpy.CalculateField_management(PathSlope__3_, "SPR", "!grid_code!", "PYTHON", "")

# Process: Delete Field
arcpy.DeleteField_management(PathSlope__6_, "GRIDCODE;grid_code")

# Process: Add Field (2)
arcpy.AddField_management(PathSlope__4_, "sprdesc", "TEXT", "", "", "", "SPR Description", "NULLABLE", "NON_REQUIRED", "")

